package roseindia.action;

import java.util.Properties;

import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;

import roseindia.model.MailerForm;

import com.opensymphony.xwork2.ActionSupport;
import com.opensymphony.xwork2.ModelDriven;

public class Mailer extends ActionSupport implements ModelDriven<MailerForm> {

	private static final long serialVersionUID = 1L;

	MailerForm model;

	@Override
	public String execute() throws Exception {
		// TODO Auto-generated method stub
		String[] recipients = new String[] { model.getMailTo() };
		String subject = model.getSubject();
		String message = model.getMessage();
		String from = "b1@localhost";

		if (model.getMailTo() != "" && model.getMessage() != ""
				&& model.getSubject() != "") {
			// Sending e-mail
			sendMail(recipients, subject, message, from);

			System.out.println("Mail Sent");
			return SUCCESS;
		} else {
			return INPUT;
		}
	}

	@Override
	public MailerForm getModel() {
		// TODO Auto-generated method stub
		model = new MailerForm();
		return model;
	}

	@Override
	public void validate() {
		// TODO Auto-generated method stub

		// Code for validation

		if (model.getMailTo() == "" || model.getMailTo() == null) {
			addFieldError("mailTo", getText("mailTo"));
		}

		if (model.getSubject() == "" || model.getSubject() == null) {
			addFieldError("subject", getText("subject"));
		}

		if (model.getMessage() == "" || model.getMessage() == null) {
			addFieldError("message", getText("message"));
		}

		super.validate();
	}

	// Method for sending e-mail
	public void sendMail(String recipients[], String subject, String message,
			String from) throws MessagingException {
		boolean debug = false;

		// Set the host smtp address like String SMTPHost = "192.168.14.123";
		String SMTPHost = "SMTP Server Host address";

		// Create properties object
		Properties properties = new Properties();

		// Set mail SMTP host in properties
		properties.put("mail.smtp.host", SMTPHost);

		// getting Session
		Session session = Session.getDefaultInstance(properties, null);
		session.setDebug(debug);

		// create a message
		Message msg = new MimeMessage(session);

		// Setting sender and Recipients address
		InternetAddress addressFrom = new InternetAddress(from);
		msg.setFrom(addressFrom);

		// Adding all recipients
		InternetAddress[] addressTo = new InternetAddress[recipients.length];
		for (int i = 0; i < recipients.length; i++) {
			addressTo[i] = new InternetAddress(recipients[i]);
		}
		msg.setRecipients(Message.RecipientType.TO, addressTo);

		// Setting e-mail header
		msg.addHeader("MailingApplication", "Struts 2 Mailing Application");

		// Setting the Subject and Content Type
		msg.setSubject(subject);
		msg.setContent(message, "text/html");
		Transport.send(msg);
	}
}